var dchat_space_available = [false,true,true,true,true];
var dchat_open_chats = [];

Drupal.behaviors.chatAppbar = function(context) {

$('#dchat_appbar_region > .dchat_appbar_button').click(function() {
    $('#dchat_listing').toggle();
    if ( $('#dchat_listing').is(':visible')) {    
        for(var i = 0; i < 5; i++) {
          if(dchat_space_available[i]) {
            $('#dchat_listing').css('right', (i*201) + 'px');
            dchat_space_available[i] = false;
            break;
          }          	
        }
    }
    else {
    	var right = $('#dchat_listing').css('right');
    	var index = parseInt(right.substring(0,right.length-2))/201;
    	dchat_space_available[index] = true;
    }
  });

  //var chats = Drupal.settings.dchat.chatting_with;
  
  var cw = readCookie('dchat_chatting_with');
  if(cw != null)
  {
    list = cw.split(',');
    
    for(var i = 0; i < list.length; i++)
    {
      openChat(list[i]);
    }
  }
};

function openChat(otheruser)
{	
	//To prevent opening a chat twice
	if($.inArray(otheruser,	dchat_open_chats) != -1)
		return;

	dchat_open_chats.push(otheruser);

 	$('div#appbar').append('<div id="dchat_button_'+otheruser+'" class="appbar-region"><span class="dchat_appbar_button">Chat with '+otheruser+'</span></div>');
 	$('body').append('<div id="dchat_chat_'+otheruser+'" class="dchat_chatbox"><div id="dchat_chat_header">'+otheruser+'<div class="dchat_chat_closebutton" onclick="closeChat(\''+otheruser+'\')">X</div></div><div id="dchat_chat_message_container"></div><textarea id="dchat_chat_input"></textarea></div>');
	
	var button = $('#dchat_button_'+otheruser);
	var chat = $('#dchat_chat_'+otheruser);
	var input = $('#dchat_chat_'+otheruser+' #dchat_chat_input');
	var output= $('#dchat_chat_'+otheruser+' #dchat_chat_message_container');
	
	loadChat(otheruser,0);
	
	button.toggle( function() {
		for(var i = 0; i < 5; i++) {
		  if(dchat_space_available[i]) {
		    chat.css('right', (i*201) + 'px');
		    input.css('right', (i*201) + 'px');
		    dchat_space_available[i] = false;
		    break;
		  }          	
		}
		
		var cw = readCookie('dchat_chatting_with')
		if(cw == null) {
			cw = otheruser
		}
		else {
			var list = cw.split(',');
			if($.inArray(otheruser,list) == -1) {
				cw += "," + otheruser;
			}
		}
		createCookie('dchat_chatting_with', cw, 1);
		chat.toggle();
	    }, function() {
		var right = chat.css('right');
		var index = parseInt(right.substring(0,right.length-2))/201;
		dchat_space_available[index] = true;
		
		var cw = readCookie('dchat_chatting_with');
		if(cw != null)
		{
			var list = cw.split(',');
			list = jQuery.grep(list, function(value) {
			    return value != otheruser;
			});
			cw = list.join(',');
			
			if(cw == null || cw == "")
				eraseCookie('dchat_chatting_with');
			else
				createCookie('dchat_chatting_with',cw,1);
		}
		chat.toggle();
	    }
	  );
	  
	  button.click();

	input.keypress(function(event) {
	  if (event.keyCode == '13') {
	     event.preventDefault();
	     output.append("<div><span class=\"dchat_chat_username\">me:</span> " + input.val() + '<div>');
	     output.attr({ scrollTop: output.attr("scrollHeight") });
	     $.post("http://www.thomashansen.me/chat/say/"+otheruser, { 'message': input.val() }, function(data){
	     });
	     input.val('');
	   }
	});
}

function closeChat(otheruser)
{
	var index = $.inArray(otheruser,dchat_open_chats)
	list.splice(index, index);

	var button = $('#dchat_button_'+otheruser);
	var chat = $('#dchat_chat_'+otheruser);
	
	button.hide();
	chat.hide();
	
	eraseCookie('dchat_chatting_with');
}

function loadChat(otheruser,lasttime)
{
	var output= $('#dchat_chat_'+otheruser+' #dchat_chat_message_container');

	$.ajax({
	  url: 'http://www.thomashansen.me/chat/read/'+otheruser+'/'+lasttime,
	  success: function(data, textStatus) {
	  			output.append(data.substring(10)); 
	  			output.attr({ scrollTop: output.attr("scrollHeight") });
	  			
	  			if($.inArray(otheruser,	dchat_open_chats) != -1)
	  				setTimeout("loadChat('"+otheruser+"','"+data.substring(0,10)+"')",500);
	  		},
	  error: function(something) {
	  			if($.inArray(otheruser,	dchat_open_chats) != -1)
	  				setTimeout("loadChat('"+otheruser+"','"+lasttime+"')",500); 
	  		},
	  cache: false
	});
}

/* Cookie management scripts from
http://www.quirksmode.org/js/cookies.html
Assumed to be in the public domain */

function createCookie(name,value,hours) {
	if (days) {
		var date = new Date();
		date.setTime(date.getTime()+(hours*60*60*1000));
		var expires = "; expires="+date.toGMTString();
	}
	else var expires = "";
	document.cookie = name+"="+value+expires+"; path=/";
}

function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}

function eraseCookie(name) {
	createCookie(name,"",-1);
}
